//===============================================================================
// Microsoft patterns & practices
// Guidance Explorer Offline Client
//===============================================================================
// Copyright  Microsoft Corporation.  All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE.
//===============================================================================



using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using GuidanceExplorer.Model;

namespace GuidanceExplorer.Controls
{
    /// <summary>
    /// Represents the root MyViews node in the tree.
    /// </summary>
    [MenuItemAttribute(10, "&File\\New Guidance Type", GuidanceExplorer.Commands.NewGuidanceType, Keys.None)]
    [MenuItemAttribute(110, "&File\\-", null, Keys.None)]
    [MenuItemAttribute(120, "&File\\&Exit", GuidanceExplorer.Commands.FileExit, Keys.None)]

    [MenuItemAttribute(200, "&Edit\\&Undo drag/drop", GuidanceExplorer.Commands.UndoDragAndDrop, Keys.Control | Keys.Z)]
    [MenuItemAttribute(210, "&Edit\\-", null, Keys.None)]
    [MenuItemAttribute(220, "&Edit\\Cut item", GuidanceExplorer.Commands.CutGuidanceItem, Keys.None)]
    [MenuItemAttribute(230, "&Edit\\Copy item", GuidanceExplorer.Commands.CopyGuidanceItem, Keys.None)]
    [MenuItemAttribute(240, "&Edit\\Paste item", GuidanceExplorer.Commands.PasteGuidanceItem, Keys.None)]
    [MenuItemAttribute(250, "&Edit\\Dele&te item", GuidanceExplorer.Commands.DeleteGuidanceItem, Keys.None)]
    [MenuItemAttribute(260, "&Edit\\-", null, Keys.None)]
    [MenuItemAttribute(270, "&Edit\\&Select All", GuidanceExplorer.Commands.SelectAll, Keys.Control | Keys.A)]

    [MenuItemAttribute(300, "&View\\Reset &Sort Order", GuidanceExplorer.Commands.ResetSortOrder, Keys.None)]
    [MenuItemAttribute(310, "&View\\&Reset Columns", GuidanceExplorer.Commands.ResetColumns, Keys.None)]
    [MenuItemAttribute(320, "&View\\Reset &Filters", GuidanceExplorer.Commands.ResetFilters, Keys.None)]
    [MenuItemAttribute(330, "&View\\&Column Chooser", GuidanceExplorer.Commands.ColumnChooser, Keys.None)]

    [MenuItemAttribute(400, "&Help\\&About", GuidanceExplorer.Commands.HelpAbout, Keys.None)]

    [MenuItemAttribute(500, "context\\New Guidance Type", GuidanceExplorer.Commands.NewGuidanceType, Keys.None)]
    public class AuthoringToolkitNode : TreeNode
    {
        /// <summary>
        /// Factory.
        /// </summary>
        /// <returns></returns>
        public static AuthoringToolkitNode New()
        {
            return new AuthoringToolkitNode();
        }

        /// <summary>
        /// The columns for this guidance type.
        /// </summary>
        private ColumnCollection _columns;

        /// <summary>
        /// Default private constructor.
        /// </summary>
        private AuthoringToolkitNode() : base("Authoring Toolkit", 0, 0) { }

        /// <summary>
        /// The columns for this guidance type.
        /// </summary>
        public ColumnCollection Columns
        {
            get { return _columns; }
            set { _columns = value; }
        }
    }
}

