//===============================================================================
// Microsoft patterns & practices
// Guidance Explorer Offline Client
//===============================================================================
// Copyright  Microsoft Corporation.  All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE.
//===============================================================================



using System;
using System.Collections.Generic;
using System.Text;

namespace GuidanceExplorer.Model
{
    public class FolderCollection : Dictionary<string,Folder>
    {
        /// <summary>
        /// Factory.
        /// </summary>
        /// <returns></returns>
        public static FolderCollection New()
        {
            return new FolderCollection();
        }

        /// <summary>
        /// Default constructor.
        /// </summary>
        private FolderCollection()
        {
        }

        public override bool Equals(object obj)
        {
            FolderCollection other = obj as FolderCollection;
            if (other != null)
            {
                if (this.Count != other.Count) return false;
                IEnumerator<Folder> _thisCollection = this.Values.GetEnumerator();
                IEnumerator<Folder> _otherCollection = other.Values.GetEnumerator();
                while (_thisCollection.MoveNext() && _otherCollection.MoveNext())
                {
                    if (!_thisCollection.Current.Equals(_otherCollection.Current))
                    {
                        return false;
                    }
                }
                return true;
            }
            else
            {
                return base.Equals(obj);
            }
        }

        public override int GetHashCode()
        {
            return base.GetHashCode();
        }
    }
}

