//===============================================================================
// Microsoft patterns & practices
// Guidance Explorer Offline Client
//===============================================================================
// Copyright  Microsoft Corporation.  All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE.
//===============================================================================



using System;
using System.Collections.Generic;
using System.Text;

namespace GuidanceExplorer.Model
{
    /// <summary>
    /// Indicates an item in the model.
    /// </summary>
    public interface IModelItem
    {
        /// <summary>
        /// The model item is editable?
        /// </summary>
        bool IsEditable { get; }

        /// <summary>
        /// Can drop the provided model node into this instance?
        /// </summary>
        /// <param name="modelItem"></param>
        /// <returns></returns>
        bool CanDrop(IModelItem modelItem);
    }
}

