//===============================================================================
// Microsoft patterns & practices
// Guidance Explorer Offline Client
//===============================================================================
// Copyright  Microsoft Corporation.  All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE.
//===============================================================================



using System;
using System.Collections.Generic;
using System.Text;
using GuidanceExplorer.Model;

namespace GuidanceExplorer.Views
{
    /// <summary>
    /// EventArgs used to send a GuidanceItem across component events.
    /// </summary>
    public class GuidanceItemEventArgs : EventArgs
    {
        /// <summary>
        /// The GuidanceItem that will be notified.
        /// </summary>
        private GuidanceItem _guidanceItem;

        /// <summary>
        /// Default constructor with the GuidanceItem instance.
        /// </summary>
        /// <param name="guidanceItem">The GuidanceItem instance.</param>
        public GuidanceItemEventArgs(GuidanceItem guidanceItem)
        {
            _guidanceItem = guidanceItem;
        }

        /// <summary>
        /// The GuidanceItem instance.
        /// </summary>
        public GuidanceItem GuidanceItem
        {
            get { return _guidanceItem; }
        }
    }
}

