//===============================================================================
// Microsoft patterns & practices
// Guidance Explorer Offline Client
//===============================================================================
// Copyright  Microsoft Corporation.  All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE.
//===============================================================================



using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

using GuidanceExplorer.Controls;

namespace GuidanceExplorer.Views
{
    public class ModelNodeEventArgs<T> : EventArgs
    {
        private ModelNode<T> _node;

        public ModelNodeEventArgs(ModelNode<T> node)
        {
            _node = node;
        }

        public T ModelInstance
        {
            get { return _node.ModelInstance; }
        }

        public ModelNode<T> ModelNode
        {
            get { return _node; }
        }
    }
}

