//===============================================================================
// Microsoft patterns & practices
// Guidance Explorer Offline Client
//===============================================================================
// Copyright  Microsoft Corporation.  All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE.
//===============================================================================



using System;
using System.Collections.Generic;
using System.Text;

namespace GuidanceExplorer.Model
{
    public class GuidanceTypeEventArgs : EventArgs
    {
        /// <summary>
        /// The guidance type instance that has been notified.
        /// </summary>
        private GuidanceType _guidanceType;

        /// <summary>
        /// Create a new GuidanceTypeEventArgs with the guidance type instance.
        /// </summary>
        /// <param name="guidanceType"></param>
        public GuidanceTypeEventArgs(GuidanceType guidanceType)
        {
            _guidanceType = guidanceType;
        }

        /// <summary>
        /// The guidance type instance that has been notified.
        /// </summary>
        public GuidanceType GuidanceType
        {
            get { return _guidanceType; }
        }
    }
}

