//===============================================================================
// Microsoft patterns & practices
// Guidance Explorer Offline Client
//===============================================================================
// Copyright  Microsoft Corporation.  All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE.
//===============================================================================



using System;
using System.Collections.Generic;
using System.Text;
using GuidanceExplorer.Model;

namespace GuidanceExplorer.Views
{
    /// <summary>
    /// EventArgs used to send a GuidanceItemCollection across component events.
    /// </summary>
    public class GuidanceItemCollectionEventArgs : EventArgs
    {
        /// <summary>
        /// The GuidanceItemCollection that will be notified.
        /// </summary>
        private GuidanceItemCollection _guidanceItemCollection;

        /// <summary>
        /// Default constructor with the GuidanceItemCollection instance.
        /// </summary>
        /// <param name="guidanceItemCollection">The GuidanceItemCollection instance.</param>
        public GuidanceItemCollectionEventArgs(GuidanceItemCollection guidanceItemCollection)
        {
            _guidanceItemCollection = guidanceItemCollection;
        }

        /// <summary>
        /// The GuidanceItemCollection instance.
        /// </summary>
        public GuidanceItemCollection GuidanceItemCollection
        {
            get { return _guidanceItemCollection; }
        }
    }
}

