//===============================================================================
// Microsoft patterns & practices
// Guidance Explorer Offline Client
//===============================================================================
// Copyright  Microsoft Corporation.  All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE.
//===============================================================================



using System;
using System.Collections.Generic;
using System.Text;

namespace GuidanceExplorer.Model
{
    public interface IGuidanceItemContainer : IEnumerable<GuidanceItem>
    {
        /// <summary>
        /// The columns for the item container.
        /// </summary>
        ColumnCollection Columns { get; set; }

        /// <summary>
        /// The items for this container.
        /// </summary>
        GuidanceItemCollection Items { get; set;}

        /// <summary>
        /// Whether the container has own items. Folders and Guidance does not have items however they compose items
        /// from contained elements, View and Library has items.
        /// </summary>
        bool HasItems { get; }

        /// <summary>
        /// Whether the Items collection can be set.
        /// </summary>
        bool CanSetItems { get; }
    }
}

