//===============================================================================
// Microsoft patterns & practices
// Guidance Explorer Offline Client
//===============================================================================
// Copyright  Microsoft Corporation.  All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE.
//===============================================================================



using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using System.IO;

namespace GuidanceExplorer.Model
{
    /// <summary>
    /// Represents the list of folders and views created by the user.
    /// </summary>
    public class UserViews : FolderStructure
    {
        /// <summary>
        /// Factory.
        /// </summary>
        /// <returns></returns>
        public static UserViews New()
        {
            return new UserViews();
        }

        /// <summary>
        /// The name of the file that defines this library.
        /// </summary>
        private FileInfo _sourceFileName;

        /// <summary>
        /// Private default constructor.
        /// </summary>
        private UserViews() { }

        /// <summary>
        /// The name of the file that defines this library.
        /// </summary>
        public FileInfo SourceFileInfo
        {
            get { return _sourceFileName; }
            set { _sourceFileName = value; }
        }
    }
}

