//===============================================================================
// Microsoft patterns & practices
// Guidance Explorer Offline Client
//===============================================================================
// Copyright  Microsoft Corporation.  All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE.
//===============================================================================



using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using GuidanceExplorer.Controls;

namespace GuidanceExplorer.Views
{

    public class DropOperationEventArgs<T,U> : EventArgs 
    {
        private ModelNode<T> _dragNode;
        private ModelNode<U> _dropNode;

        public DropOperationEventArgs(ModelNode<T> dragNode, ModelNode<U> dropNode)
        {
            _dragNode = dragNode;
            _dropNode = dropNode;
        }

        public ModelNode<T> DragNode
        {
            get { return _dragNode; }
        }

        public T DragModelInstance
        {
            get { return _dragNode.ModelInstance; }
        }

        public ModelNode<U> DropNode
        {
            get { return _dropNode; }
        }

        public U DropModelInstance
        {
            get { return _dropNode.ModelInstance; }
        }
    }

}

