//===============================================================================
// Microsoft patterns & practices
// Guidance Explorer Offline Client
//===============================================================================
// Copyright  Microsoft Corporation.  All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE.
//===============================================================================

using System;
using System.IO;
using System.Collections.Generic;
using System.Collections;
using System.ComponentModel;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Reflection;

using Microsoft.Practices.CompositeUI.SmartParts;
using GuidanceExplorer.Config;

namespace GuidanceExplorerNT
{
    [SmartPart]
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();

            //Get the configuration section
            GuidanceExplorerSection section = ConfigurationManager.GetSection("GuidanceExplorer") as GuidanceExplorerSection;

            //Set the title to the form.
            this.Text = section.Title;

            this.Icon = new Icon(Assembly.GetExecutingAssembly().GetManifestResourceStream("GuidanceExplorer.MainIcon.ico"));
        }

        /// <summary>
        /// Hack to avoid CAB closing the forms without calling the propper events.
        /// </summary>
        /// <param name="e"></param>
        protected override void OnClosing(CancelEventArgs e)
        {
            int i = 0;
            Form[] forms = new Form[Application.OpenForms.Count - 1];
            IEnumerator fenum = Application.OpenForms.GetEnumerator();
            while (fenum.MoveNext())
            {
                Form f = fenum.Current as Form;
                if (!(f is MainForm))
                {
                    forms[i++] = f;
                }
            }

            foreach (Form ff in forms)
            {
                e.Cancel = true;
                ff.Close();
            }

            string dir = Path.Combine(Path.GetTempPath(), "GE");
            if (Directory.Exists(dir))
            {
                Directory.Delete(dir, true);
            }
        }
    }
}
