using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.IO;
using System.Collections.Generic;
using System.Xml;
using Resources;
using System.Xml.Schema;
using System.Text;
using GuidanceExplorer.Services;
using GuidanceExplorer.Model;

#region With Sync
public partial class Default2 : System.Web.UI.Page
{
    ModelStorageService _modelStorageService;
    string _currentDirectory;
    string _getItemsUrl;
     
    protected void Page_Load(object sender, EventArgs e)
    {
        if (this.Page.IsPostBack)
            return;


        //this.ClientScript.RegisterStartupScript(this.Page.GetType(), string.Empty, string.Format("<script>panelGetItemsList = {0}</script>", this.PanelItemsList), true);





        try
        {
            string url = this.Request.Url.ToString().Split('?')[0];
            
            _currentDirectory = Server.MapPath(this.Request.Url.LocalPath.Replace(Path.GetFileName(url), ""));
            _getItemsUrl = url.Replace(Path.GetFileName(url), string.Empty) + "ItemsList.aspx";

            //WebFormRenderService webFormRenderService = new WebFormRenderService(_getItemsUrl, this.PanelItemsList.ClientID, _currentDirectory);
            WebFormRenderService webFormRenderService = new WebFormRenderService(url, _getItemsUrl, this.PanelItemsList.ClientID, _currentDirectory);
            webFormRenderService.RenderGuidanceToTreeView(this.ModelStorageService.Guidance, this.LibrariesTree);
            this.LibrariesTree.Attributes.Add("onclick", "javascript:return TreeNodeSelected();");

            if (string.IsNullOrEmpty(this.Request["Query"]))
            {
                if (this.Request.Url.ToString().Contains(_getItemsUrl))
                {
                    this.ClientScript.RegisterStartupScript(this.Page.GetType(), string.Empty, "javascript:GetItemsListByUrl('" + this.Request.Url.ToString() + "');", true);
                }
                else
                {
                    this.ClientScript.RegisterStartupScript(this.Page.GetType(), string.Empty, webFormRenderService.StartupScript, true);
                }
            }
            else
            {
                Utilities.BuildClientQueryScript(this.Request.QueryString);
            }
        }
        catch (Exception)
        {
        }
    }

    private ModelStorageService ModelStorageService
    {
        get
        {
            if (_modelStorageService != null)
                return _modelStorageService;

            if (this.Application["ModelStorageService"] == null)
            {
                _modelStorageService = new ModelStorageService();
                _modelStorageService.LoadGuidance(Path.Combine(_currentDirectory, ConfigurationManager.AppSettings["GuidanceTypesDirectory"]), ClientFlavour.Online);
                GuidanceExplorer.Services.AsyncLoadLibrariesService asyncLoadSLibraryService = new GuidanceExplorer.Services.AsyncLoadLibrariesService();
                asyncLoadSLibraryService.ProcessGuidance(_modelStorageService.Guidance, null);
                
                this.Application["ModelStorageService"] = _modelStorageService;
            }
            else
            {
                _modelStorageService = (ModelStorageService)this.Application["ModelStorageService"];
            }

            return _modelStorageService;
        }
    }
}
#endregion

#region Without Sync
//public partial class Default2 : System.Web.UI.Page
//{
//    ModelStorageService _modelStorageService;
//    string _currentDirectory;
//    protected void Page_Load(object sender, EventArgs e)
//    {
//        if (this.Page.IsPostBack)
//            return;

//        _currentDirectory = Server.MapPath(this.Request.Url.LocalPath.Replace(Path.GetFileName(this.Request.Url.ToString()), ""));

//        string getItemsUrl = this.Request.Url.ToString().Replace(Path.GetFileName(this.Request.Url.ToString()), string.Empty) + "ItemsList.aspx";


//        GuidanceExplorer.Services.ModelStorageService modelStorageService = new GuidanceExplorer.Services.ModelStorageService();
//        modelStorageService.LoadGuidance(System.IO.Path.Combine(_currentDirectory, ConfigurationManager.AppSettings["GuidanceTypesDirectory"]), GuidanceExplorer.Model.ClientFlavour.Online);
//        this.Application["ModelStorageService"] = modelStorageService;

//        GuidanceExplorer.Services.AsyncLoadLibrariesService asyncLoadSLibraryService = new GuidanceExplorer.Services.AsyncLoadLibrariesService();
//        asyncLoadSLibraryService.ProcessGuidance(modelStorageService.Guidance, null);

//        WebFormRenderService webFormRenderService = new WebFormRenderService(getItemsUrl, this.PanelItemsList.ClientID, _currentDirectory);
//        webFormRenderService.RenderGuidanceToTreeView(this.ModelStorageService.Guidance, this.LibrariesTree);
//        this.ClientScript.RegisterStartupScript(this.Page.GetType(), string.Empty, webFormRenderService.StartupScript, true);
//    }

//    private ModelStorageService ModelStorageService
//    {
//        get
//        {
//            if (_modelStorageService != null)
//                return _modelStorageService;

//            if (this.Application["ModelStorageService"] == null)
//            {
//                _modelStorageService = new ModelStorageService();
//                _modelStorageService.LoadGuidance(Path.Combine(_currentDirectory, ConfigurationManager.AppSettings["GuidanceTypesDirectory"]), ClientFlavour.Online);
//                this.Application["ModelStorageService"] = _modelStorageService;
//            }
//            else
//            {
//                _modelStorageService = (ModelStorageService)this.Application["ModelStorageService"];
//            }
//            return _modelStorageService;
//        }
//    }
//}
#endregion