using System;
using System.Data;
using System.IO;
using System.Configuration;
using System.Collections;
using System.Text;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml;
using System.Globalization;
using GuidanceExplorer;
using GuidanceExplorer.Model;
using GuidanceExplorer.Services;

public partial class Filters : System.Web.UI.Page
{
    string _guidanceType;
    string _parent;
    string _filterQuery;
    string _filterExpression;
    string _url; 
    string _header;
    string _type;
    string _viewId;
    string _textToSearch;
    ModelStorageService _modelStorageService;

    private void Initialize()
    {
        _guidanceType = this.Request["guidanceType"].Replace("'", "");
        _parent = this.Request["Parent"];
        _filterQuery = this.Request["FilterQuery"] == null ? string.Empty : this.Request["FilterQuery"];
        _filterExpression = this.Request["Header"];
        _url = this.Request.Url.ToString().Split('?')[0];
        _header = this.Request["Header"];
        _type = this.Request["Type"];
        _viewId = this.Request["ViewId"];
        _textToSearch = this.Request["TextToSearch"];
    }
    
    protected void Page_Load(object sender, EventArgs e)
    {
        this.Initialize();
        StringWriter tw = new StringWriter();
        HtmlTextWriter hw = new HtmlTextWriter(tw);
        tw.WriteLine(this.GetFilters());
        Response.Write(tw.ToString());
        Response.End();
    }

    private string GetFilters()
    {
        Source source = _type == Constants.Library ? SourceManagment.GetLibraryItems(this.ModelStorageService, _guidanceType, _parent, _textToSearch) : SourceManagment.GetViewItems(this.ModelStorageService, _parent, _guidanceType, _viewId, _textToSearch);
        ArrayList filters = new ArrayList();
        StringBuilder outHtml = new StringBuilder();
        outHtml.Append("<table>");
                        
        if (!string.IsNullOrEmpty(_filterQuery))
        {
            string rowFilter = string.Empty;
            string[] filtersAux = _filterQuery.Split(Constants.FiltersSeparator);
            foreach (string filter in filtersAux)
            {
                string[] values = filter.Split(Constants.FilterValueSeparator);
                string filterExpression = values[0];
                string filterValue = HttpUtility.UrlDecode(values[1]);
                if (rowFilter != string.Empty)
                    rowFilter += " AND " + string.Format("{0} = '{1}'", filterExpression, filterValue);
                else
                    rowFilter += string.Format("{0} = '{1}'", filterExpression, filterValue);
            }
            source.Data.DefaultView.RowFilter = rowFilter;
        }

        foreach (DataRowView row in source.Data.DefaultView)
        {
            if (!filters.Contains(Utilities.Capitalize(row[_filterExpression].ToString().ToLower())))
                filters.Add(Utilities.Capitalize(row[_filterExpression].ToString().ToLower()));
        }

        outHtml.Append(string.Format("<tr><td><a style='cursor:hand;font-family:Microsoft Sans Serif; font-size:9;' onclick=javascript:GetFilteredItemsList('{0}','{1}','{2}','{3}','{5}');>{4}</a></td></tr>", HttpUtility.UrlEncode(_guidanceType), _parent, _header, "All", "(all)", _url.Replace("Filters.aspx", "ItemsList.aspx")));
        Comparer comparer = new Comparer(CultureInfo.CurrentCulture);
        filters.Sort(comparer);

        foreach (string filter in filters)
        {
            if (filter == string.Empty)
                continue;
            outHtml.Append(string.Format("<tr><td><a style='cursor:hand;font-family:Microsoft Sans Serif; font-size:9' onclick=javascript:GetFilteredItemsList('{0}','{1}','{2}','{3}','{5}');>{4}</a></td></tr>", HttpUtility.UrlEncode(_guidanceType), _parent, _header, HttpUtility.UrlEncode(filter), filter, _url.Replace("Filters.aspx", "ItemsList.aspx")));
        }

        outHtml.Append("</table>");
        return outHtml.ToString();
    }

    private ModelStorageService ModelStorageService
    {
        get
        {
            if (_modelStorageService != null)
                return _modelStorageService;

            if (this.Application["ModelStorageService"] == null)
            {
                string currentDirectory = Server.MapPath(this.Request.Url.LocalPath.Replace(Path.GetFileName(this.Request.Url.ToString().Split('?')[0]), ""));
                _modelStorageService = new ModelStorageService();
                _modelStorageService.LoadGuidance(currentDirectory + ConfigurationManager.AppSettings["GuidanceTypesDirectory"], ClientFlavour.Online);
                this.Application["ModelStorageService"] = _modelStorageService;
            }
            else
            {
                _modelStorageService = (ModelStorageService)this.Application["ModelStorageService"];
            }
            return _modelStorageService;
        }
    }
}