<%@ Application Language="C#" %>

<script runat="server">

    private static System.Threading.AutoResetEvent _autoEvent;
    private static System.Threading.TimerCallback _timerDelegate;
    private static System.Threading.Timer _stateTimer;
    private static string _currentDirectory;
    
        
    void Application_Start(object sender, EventArgs e) 
    {
        string url = this.Context.Request.Url.ToString().Split('?')[0];
        _currentDirectory = this.Server.MapPath(this.Context.Request.Url.LocalPath.Replace(System.IO.Path.GetFileName(url), ""));
        
       this.Synchronice(this.Application);

        _autoEvent = new System.Threading.AutoResetEvent(false);
        _timerDelegate = new System.Threading.TimerCallback(Synchronice);
        _stateTimer = new System.Threading.Timer(_timerDelegate, _autoEvent, 3600000, 3600000); //Synchronization each hour
    }
    
    void Application_End(object sender, EventArgs e) 
    {
        //  Code that runs on application shutdown

    }
        
    void Application_Error(object sender, EventArgs e) 
    { 
        // Code that runs when an unhandled error occurs

    }

    void Session_Start(object sender, EventArgs e) 
    {
        // Code that runs when a new session is started

    }

    void Session_End(object sender, EventArgs e) 
    {
        // Code that runs when a session ends. 
        // Note: The Session_End event is raised only when the sessionstate mode
        // is set to InProc in the Web.config file. If session mode is set to StateServer 
        // or SQLServer, the event is not raised.
    }
    
    void Synchronice(Object state)
    {
        try
        {
            GuidanceExplorer.Services.ModelStorageService modelStorageService = new GuidanceExplorer.Services.ModelStorageService();
            modelStorageService.LoadGuidance(System.IO.Path.Combine(_currentDirectory, ConfigurationManager.AppSettings["GuidanceTypesDirectory"]), GuidanceExplorer.Model.ClientFlavour.Online);

            GuidanceExplorer.Services.AsyncLoadLibrariesService asyncLoadSLibraryService = new GuidanceExplorer.Services.AsyncLoadLibrariesService();
            asyncLoadSLibraryService.ProcessGuidance(modelStorageService.Guidance, null);

            GuidanceExplorer.Services.OnlineStorageService oss = new GuidanceExplorer.Services.OnlineStorageService();
            GuidanceExplorer.Services.HtmlRenderService htmlRS = new GuidanceExplorer.Services.HtmlRenderService();
            System.IO.Directory.SetCurrentDirectory(Server.MapPath("bin"));
            oss.Syncronize(modelStorageService, htmlRS, false, true, null);
            
            this.Application["ModelStorageService"] = modelStorageService;
        }
        catch (Exception)
        {
            return;
        }
    }
</script>
