using System;
using System.Data;
using System.IO;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml;
using GuidanceExplorer;
using GuidanceExplorer.Model;
using GuidanceExplorer.Services;

public partial class ItemData : System.Web.UI.Page
{
    private ModelStorageService _modelStorageService;
    protected void Page_Load(object sender, EventArgs e)
    {
        string id = this.Request["ItemId"];
        if (id == null)
            return;
               
        GuidanceItem guidanceItem = this.ModelStorageService.FindItemById(id);
        HtmlRenderService htmlRenderService = new HtmlRenderService();
        Stream stream = htmlRenderService.GetDocumentStreamForShowing(guidanceItem as GuidanceItemFileReference);
        string html = null;
        using (StreamReader sr = new StreamReader(stream))
        {
            html = sr.ReadToEnd();
        }
        this.RenderHtml(html);
        
    }
    
    private void RenderHtml(string html)
    {
        string htmlResult = html;
        
        if (this.Request["FromPage"] == "1")
        {
            string link = this.Request.Url.ToString().Replace("&FromPage=1", "");
            Response.Write(string.Format("<table style='border:0;font:normal 7pt Arial'><tr ><td style='border:0'><a title='Send link' href=\"mailto:?body={1}\"><img  style=border:0 src=./Images/email.bmp style=cursor:pointer/></a>Send&nbsp;</td><td style='border:0'><img src='./Images/copy.bmp' alt='Copy link' style='cursor:pointer' onclick=\"javascript:return CopyLink('{0}');\"/>Copy&nbsp;</td><td style='border:0;vertical-align:middle;'><img src=./Images/link.bmp style='cursor:pointer' alt='Open link in a new window' onclick=\"javascript:return OpenLinkNewWindow('{0}');\"/>Open</td></tr></table>", link, HttpUtility.UrlEncode(link)));
            Response.Write("<Features>");

            Response.Write(htmlResult.Replace("<A href=", "<A class='externLink' href="));
            Response.End();
        }


        string url = this.Request.Url.ToString().Split('?')[0].Replace(Path.GetFileName(this.Request.Url.ToString().Split('?')[0]), ""); ;
        string header = "<table style=\"height:20px;border:0 none white\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\"><tr style=\"background-image:url(./Images/shade1.bmp)\"><td valign=\"top\" style=\"height:20px\"><img src=\"./Images/GuidanceLibraryOnLine.gif\" alt=\"Guidance Library\" /></td></tr><tr><td align=\"right\" font=\"Arial 10pt\"><a href=\"" + url + "\">Guidance Explorer Home</a></td></tr></table>";

        Response.Write(header);
        Response.Write("<body id=\"bodyId\" style=\"height:100%;width:100%;border-spacing:0;padding:0;padding-left:0;padding-right:0;padding:0;padding-bottom:0;padding-top:0; margin: 0px 2px 0px 0px\">");
        Response.Write(htmlResult);
        Response.End();
    }

    private ModelStorageService ModelStorageService
    {
        get
        {
            if (_modelStorageService != null)
                return _modelStorageService;

            if (this.Application["ModelStorageService"] == null)
            {
                string currentDirectory = Server.MapPath(this.Request.Url.LocalPath.Replace(Path.GetFileName(this.Request.Url.ToString().Split('?')[0]), ""));
                _modelStorageService = new ModelStorageService();
                _modelStorageService.LoadGuidance(currentDirectory + ConfigurationManager.AppSettings["GuidanceTypesDirectory"], ClientFlavour.Online);

                GuidanceExplorer.Services.AsyncLoadLibrariesService asyncLoadSLibraryService = new GuidanceExplorer.Services.AsyncLoadLibrariesService();
                asyncLoadSLibraryService.ProcessGuidance(_modelStorageService.Guidance, null);
                this.Application["ModelStorageService"] = _modelStorageService;
            }
            else
            {
                _modelStorageService = (ModelStorageService)this.Application["ModelStorageService"];
            }
            return _modelStorageService;
        }
    }
}
