﻿/************************************************************************

    Globals

************************************************************************/
var panelGetItemsList;
var panelGetSortedItemsList;
var globalTitle;
var xmlhttp = GetXMLHttp();
var itemValue;
var itemsCount = 0;
var itemSelected;
var filterQuery = '';
var filtersSeparator = '$';
var filterValueSeparator = '|';



/************************************************************************

    GetXMLHttp

************************************************************************/
function GetXMLHttp()
{
    var xmlhttp=false;

    try 
    {
        if (window.XMLHttpRequest)
          {
              xmlhttp = new XMLHttpRequest();
          }
          else
          {
                xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
                
          }
    } 
    catch (e) 
    {
        try 
        {
            xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
        }
        catch (E)
        {
            xmlhttp = false;
        }
    }

    if (!xmlhttp && typeof XMLHttpRequest!='undefined')
       xmlhttp = new XMLHttpRequest();
    
    return xmlhttp;
}

/************************************************************************

    GetItemsList

************************************************************************/
function GetItemsListByUrl(url)
{
    var split = url.split("?");
    var split2 = split[1].split("&");
    if (split2.length == 6)
        GetItemsList(split2[0], split2[1], split2[2], split2[3], split2[4], split2[5]); 
    else
        return;
}

function GetItemsList(guidanceType, path, panelClientId, parent, type, viewId)
{
    sortExpression = "Date";
    sortDirection = "Descending";
    panelGetItemsList = panelClientId;
    filterQuery = '';
    EnableLoading(false);

    window.document.getElementById("hdnItemValue").value = guidanceType;
    window.document.getElementById("hdnViewId").value = viewId;
    window.document.getElementById("hdnItemType").value = type;
    window.document.getElementById("hdnItemsListUrl").value = path;
    window.document.getElementById("hdnPanelItemsListId").value = panelClientId;
    window.document.getElementById("hdnItemParent").value = parent;
    
    window.document.getElementById("hdnSortExpression").value = sortExpression;
    window.document.getElementById("hdnSortDirection").value = sortDirection;
    
    url = path + "?GuidanceType=" + guidanceType + "&ClientId=" + panelClientId + "&Type=" + type + "&hash=" + Math.random(); 
    url = url + "&" + "SortExpression=" + sortExpression + "&SortDirection=" + sortDirection;
    
    url += "&Parent=" + parent;
    url += "&ViewId=" + viewId;
        
    panelGetItemsList = panelClientId;
    xmlhttp.open("GET",url,true);
    xmlhttp.onreadystatechange = GetItemsListCallBack;
    xmlhttp.send();
}

function GetItemsListCallBack()
{
    if (xmlhttp.readyState==4)
    {
   
        box = window.document.getElementById(panelGetItemsList);
        SetPager(xmlhttp.responseText);
        
        box.innerHTML = ParsePager(xmlhttp.responseText);
        
        window.document.getElementById("searchBox").value = "";
        
        DisableLoading();
    }
}
/************************************************************************

    GetItemData

************************************************************************/
function GetItemData(url)
{    
    table = event.srcElement.parentNode.parentNode.parentNode;
    for (i = 0; i < table.rows.length; i++)
        if (table.rows[i].style.background == 'beige')
            table.rows[i].style.background = 'white';
    
    row = event.srcElement.parentNode.parentNode;
    row.style.background='beige';
    url +="&FromPage=1"; 
    
    
    xmlhttp.open("GET", url, true);
    xmlhttp.onreadystatechange = GetItemDataCallBack;
    GetItemDataCallBack.url = url;
    xmlhttp.send();
}

function GetItemDataCallBack()
{
    if (xmlhttp.readyState==4)
    {
        box = window.document.getElementById("itemDetail");
        
        str = xmlhttp.responseText.split('<Features>');
        //window.document.getElementById("Features").innerHTML = str[0];
        data = str[1].toString();
        //var data2 = data.split('</body>');
        //var data3 = data2[0] + '<li> URL:' + GetItemDataCallBack.url + '</li></body>' + data2[1]; 

        var divh = document.createElement( 'DIV' );
        divh.style.width = '100%';
        divh.align = 'right';
        divh.innerHTML = str[0];
        var div = document.createElement( 'DIV' );
        //div.innerHTML = data3;
        div.innerHTML = data;
        
        if (box.children.length != 0)
        {
            var child0 = box.children(0);
            var child1 = box.children(1);
            box.removeChild(child0);
            box.removeChild(child1);
        }
        
        box.appendChild(divh);
        box.appendChild(div);
        box.parentNode.parentNode.scrollTop = 0;
        DisableLoading();
    }
}

/************************************************************************

    GetSortedItemsList

************************************************************************/
function GetSortedItemsList(guidanceType, path, panelClientId, sortExpression, sortDirection, textToSearch, filterQuery, parent, type, viewId)
{
    panelGetItemsList = panelClientId;
    EnableLoading(false);

    url = path + "?GuidanceType='" + guidanceType + "'" + "&" + "SortExpression=" + sortExpression + "&SortDirection=" + sortDirection + "&ClientId=" + panelClientId + "&hash=" + Math.random(); 
    url += "&TextToSearch='" + textToSearch + "'";
    url += "&Type=" + type;
    url += "&FilterQuery=" + filterQuery;
        
    window.document.getElementById('hdnSortExpression').value = sortExpression;
    window.document.getElementById('hdnSortDirection').value = sortDirection;
    
    pageIndex = window.document.getElementById('hdnPageIndex').value;
    
    url = url + "&PageIndex=" + pageIndex;
    url += "&Parent=" + parent;
    url += "&ViewId=" + viewId;
    
    xmlhttp.open("GET", url, true);
    panelGetSortedItemsList = panelClientId;
    xmlhttp.onreadystatechange = GetSortedItemsListCallBack;
    xmlhttp.send();
            
    return false;
}

function GetSortedItemsListCallBack()
{
    if (xmlhttp.readyState==4)
    {
        window.setTimeout(DrawSortedItems, 1000);
    }
}

function DrawSortedItems()
{
    box = window.document.getElementById(panelGetSortedItemsList);
    SetPager(xmlhttp.responseText);
    box.innerHTML = ParsePager(xmlhttp.responseText);
    DisableLoading();
}


/************************************************************************

    Search

************************************************************************/
function Search()
{
    text = window.document.getElementById('searchBox').value;
    if (text.length == 0)
    {
        window.alert('TextBox empty');
        return false;
    }
    
    EnableLoading(true);
    window.document.getElementById("hdnSortExpression").value = '';
    window.document.getElementById("hdnSortDirection").value = '';
   
    url = window.document.getElementById("hdnItemsListUrl").value;
    url += '?TextToSearch=' + "'"  + text + "'";
    url += '&GuidanceType=' + window.document.getElementById("hdnItemValue").value;
    url += '&Parent=' + window.document.getElementById("hdnItemParent").value;
    url += '&Type=' + window.document.getElementById("hdnItemType").value;
    url += '&ViewId=' + window.document.getElementById("hdnViewId").value;
    
    url += '&ClientId=' + panelGetItemsList;
    url += '&hash=' + Math.random();
    
    //window.document.getElementById("btnClear").style.visibility = 'visible';
    
    xmlhttp.open("GET", url, true);
    xmlhttp.onreadystatechange = SearchCallBack;
    xmlhttp.send();
    return false;
}

function SearchCallBack()
{
    if (xmlhttp.readyState==4)
    {
        window.setTimeout(DrawSearch, 1000);
     }
}

function DrawSearch()
{
       box = window.document.getElementById(panelGetItemsList);
        
        if (box == null)
            return;
        
        SetPager(xmlhttp.responseText);
        box.innerHTML = ParsePager(xmlhttp.responseText);

        
        if (box.innerText == "")
        {
            itemsCount = 0;
        }
        DisableLoading();
}

/************************************************************************

    TreeNodeSelected

************************************************************************/
function TreeNodeSelected()
{
    if (event.srcElement.innerText == "")
        return;
        
    if (event.srcElement.tagName != "A")
        return;
    
    if (itemSelected != null)
        itemSelected.style.fontWeight='normal';    
        
    itemSelected = event.srcElement;
    itemSelected.style.fontWeight='bold';  
}

/************************************************************************

    PageView

************************************************************************/
function PageView(index, filterQuery)
{
    EnableLoading(false);
    window.document.getElementById("hdnPageIndex").value = index;
   
    url = window.document.getElementById("hdnItemsListUrl").value;
    url += '?GuidanceType=' + window.document.getElementById("hdnItemValue").value;
    url += '&Parent=' + window.document.getElementById("hdnItemParent").value;
    url += '&ClientId=' + panelGetItemsList;
    url += '&Type=' + window.document.getElementById("hdnItemType").value;
    url += '&PageIndex=' + index;
    url += '&FilterQuery=' + filterQuery;
    url += '&ViewId=' + window.document.getElementById("hdnViewId").value;
    
    if (window.document.getElementById("hdnSortExpression").value != '')
    {
        url += "&SortExpression=" + window.document.getElementById("hdnSortExpression").value;
        url += "&SortDirection=" + window.document.getElementById("hdnSortDirection").value;
    }   
    
    url += "&hash=" + Math.random();
    xmlhttp.open("GET", url, true);
    xmlhttp.onreadystatechange = PageViewCallBack;
    xmlhttp.send();
}

function PageViewCallBack()
{
    if (xmlhttp.readyState==4)
    {
        box = window.document.getElementById(panelGetItemsList);
        SetPager(xmlhttp.responseText);
        box.innerHTML = ParsePager(xmlhttp.responseText);
        DisableLoading();
    }
}

/************************************************************************************************************************************************
    Features
************************************************************************************************************************************************/
function doSomething()
{
    if (event.srcElement.className != 'Filter')
        window.document.getElementById("divFilter").style.visibility = 'hidden';
    
    if (event.srcElement.className == 'ARef')
    {
        GetItemData(event.srcElement.href);
        event.returnValue = false;
    }
    
    if (event.srcElement.className == 'externLink')
    {
        window.open(event.srcElement.href, '_blank');
        event.returnValue = false;
    }
    
    
    //Click on the textTree
    if (event.srcElement.href != null && event.srcElement.href.split("ItemsList.aspx").length == 2)
    {
        GetItemsListByUrl(event.srcElement.href);
        event.returnValue = false;
    }
    
    //Click on the imageTree
    if (event.srcElement.parentElement != null && event.srcElement.parentElement.href != null && event.srcElement.parentElement.href.split("ItemsList.aspx").length == 2)
    {
        event.returnValue = false;
    }

    return true;
}

function EnableLoading(search)
{
    box = window.document.getElementById('tdPager');
    
    if (box == null)
        return;
    box.innerHTML = "<div align='left' style='heigth:100%'><table><tr><td style='font:normal bolder 10pt Arial'>Loading please wait...</td></tr></table></div>";    
    
    box = window.document.getElementById(panelGetItemsList);
    box.innerHTML = "";
    if (search)
        window.status = "Executing Search...";
    else
        window.status = "Loading Items...";
}
function DisableLoading()
{
    window.status = "Done";
}
function KeyPress()
{
    if (event.keyCode == 13 && window.document.getElementById("searchBox").value != "")
    {
        Search();
        event.returnValue = false;
    }
}
function SetPager(text)
{
    str = text.split("<PAGER/>");
    str = str[0];
    
    window.document.getElementById("tdPager").innerHTML = str;
}
function ParsePager(text)
{
    str = text.split("<PAGER/>");
    return str[1];
}
function OnItemListScroll()
{
    window.document.getElementById("divFilter").style.visibility = 'hidden';
    return false;
}
function CopyLink(link)
{
    var holdtext = window.document.getElementById("holdtext");
    holdtext.innerText = link;
    Copied = holdtext.createTextRange();
    Copied.execCommand("Copy");
    return false;
}
function OpenLinkNewWindow(link)
{
    window.open(link, '_blank');
}

/************************************************************************************************************************************************
    Filters
************************************************************************************************************************************************/
/************************************************************************

    GetFiltersBy

************************************************************************/
function GetFiltersBy(guidanceType, parent, path, header, type, viewId, textToSearch)
{
    var divFilter = window.document.getElementById("divFilter");
    divFilter.style.visibility = "visible";
    divFilter.style.left = event.clientX;
    divFilter.style.top = event.clientY;
    divFilter.style.posLeft = event.clientX;
    divFilter.style.posTop = event.clientY;
    divFilter.innerHTML = "Loading....";    
    
    url = path + "?GuidanceType='" + guidanceType + "'";
    url += "&Parent=" + parent;  
    url += "&Header=" + header;
    url += "&FilterQuery=" + filterQuery;
    url += '&Type=' + type;
    url += '&ViewId=' + viewId;
    url += '&TextToSearch=' + textToSearch;
        
    url += "&hash=" + Math.random();
    xmlhttp.open("GET", url, true);
    xmlhttp.onreadystatechange = GetFiltersByCallBack;
    xmlhttp.send();
    return false;
}

function GetFiltersByCallBack()
{
    if (xmlhttp.readyState==4)
    {
        var divFilter = window.document.getElementById("divFilter");
        divFilter.innerHTML = xmlhttp.responseText;        
    }
}

/************************************************************************

    GetFilteredItemsList

************************************************************************/
function GetFilteredItemsList(guidanceType, parent, filterExpression, filterValue, url)
{
    window.document.getElementById("hdnItemValue").value = guidanceType;
    window.document.getElementById("hdnItemParent").value = parent;
       
    EnableLoading();

    url += "?GuidanceType='" + guidanceType + "'" + "&hash=" + Math.random(); 
    url += "&FilterQuery=" + BuildFilterQuery(filterExpression, filterValue);
    url += "&ClientId=" + window.document.getElementById("hdnPanelItemsListId").value;
    url += "&Parent=" + parent;
    url += "&Type=" + window.document.getElementById("hdnItemType").value;
    url += "&ViewId=" + window.document.getElementById("hdnViewId").value;

    xmlhttp.open("GET", url, true);
    xmlhttp.onreadystatechange = GetFilteredItemsListCallBack;
    xmlhttp.send();
}

function GetFilteredItemsListCallBack()
{
    if (xmlhttp.readyState==4)
    {
        window.setTimeout(DrawFilteredItems, 1000);
    }
}

function DrawFilteredItems()
{
    box = window.document.getElementById(panelGetItemsList);
    SetPager(xmlhttp.responseText);
    box.innerHTML = ParsePager(xmlhttp.responseText);
    box.scrollTop = 0;
    DisableLoading();
}

/************************************************************************

    BuildFilterQuery

************************************************************************/
function BuildFilterQuery(filterExpression, filterValue)
{
    filters = filterQuery.split(filtersSeparator);
    auxQuery = '';
    for (i = 0; i < filters.length; i++)
    {
        values = filters[i].split(filterValueSeparator);
        if (values[0] != filterExpression)
        {
            if (auxQuery == '')
            {
                auxQuery += filters[i];
            }
            else
            {
                auxQuery += filtersSeparator + filters[i];
            }
        }
    }
    filterQuery = auxQuery;
    if (filterValue != 'All')
    {
        auxQuery = filterExpression + filterValueSeparator + filterValue;
        
        if (filterQuery == "")
            filterQuery = auxQuery;
        else
            filterQuery += filtersSeparator + auxQuery;
    }
    return filterQuery;
}

/************************************************************************************************************************************************
    Synchronization
************************************************************************************************************************************************/
/************************************************************************

    Synchronize

************************************************************************/
function Synchronize(url)
{
    url += "&hash=" + Math.random();
    xmlhttp.open("GET", url, true);
    xmlhttp.onreadystatechange = SynchronizeCallBack;
    xmlhttp.send();
}

function SynchronizeCallBack()
{
    if (xmlhttp.readyState==4)
    {
        DisableLoading();
    }
}