using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using StorageTestClient.OnlineStorage;

namespace StorageTestClient
{
    public partial class Form1 : Form
    {
        OnlineStorage.OnlineStorage _storage = new OnlineStorage.OnlineStorage();

        public Form1()
        {
            InitializeComponent();

            NavigationTree navTree = _storage.GetNavigationTree(0);

            TreeNode myViewsNode = treeView1.Nodes.Add("My Views");
            foreach (StorageTestClient.OnlineStorage.View view in navTree.UserViews.Views)
            {
                TreeNode viewNode = myViewsNode.Nodes.Add(view.caption);
                viewNode.Tag = view;
            }
            TreeNode librariesNode = treeView1.Nodes.Add("Libraries");
            foreach (Library library in navTree.Libraries.Library)
            {
                TreeNode libraryNode = librariesNode.Nodes.Add(library.caption);
                libraryNode.Tag = library;
                foreach (StorageTestClient.OnlineStorage.View view in library.Views)
                {
                    TreeNode viewNode = libraryNode.Nodes.Add(view.caption);
                    viewNode.Tag = view;
                }
            }
        }

        private void treeView1_AfterSelect(object sender, TreeViewEventArgs e)
        {
            Library library = e.Node.Tag as Library;
            StorageTestClient.OnlineStorage.View view = e.Node.Tag as StorageTestClient.OnlineStorage.View;
            StorageTestClient.OnlineStorage.ListView listView = null;

            if (library != null)
            {
                listView = _storage.GetListViewForNodeId(library.id, string.Empty, null, 0, 0);
            }
            else if (view != null)
            {
                listView = _storage.GetListViewForNodeId(view.id, string.Empty, null, 0, 0);
            }

            if (listView != null)
            {
                listView1.Items.Clear();
                listView1.Columns.Clear();
                foreach (ColumnDefinition column in listView.ColumnDefinitions)
                {
                    ColumnHeader header = new ColumnHeader();
                    header.Text = column.caption;
                    header.Tag = column;
                    listView1.Columns.Add(header);
                }
                if (listView.Content.GuidanceItem != null)
                {
                    foreach (GuidanceItem guidanceItem in listView.Content.GuidanceItem)
                    {
                        ListViewItem item = new ListViewItem(new string[] { guidanceItem.title });
                        item.Tag = guidanceItem;
                        listView1.Items.Add(item);
                    }
                }
            }
        }

        private void listView1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (listView1.SelectedItems.Count != 0)
            {
                ListViewItem item = listView1.SelectedItems[0];
                GuidanceItem guidanceItem = item.Tag as GuidanceItem;

                webBrowser1.DocumentText = _storage.GetGuidanceItemContent(guidanceItem.id);
            }
        }
    }
}